# apps/auth/serializers.py

from apps.auth.models import SignUpEmailVerification, SignUpPhoneVerification
from datetime import datetime

def serialize_sign_up_email_verification(sign_up_email_verification: SignUpEmailVerification) -> dict:
    """Serialize SignUpEmailVerification object for response."""
    return {
        'id': sign_up_email_verification.id,
        'email': sign_up_email_verification.email,
        'is_email_verified': sign_up_email_verification.is_email_verified,
        'otp': sign_up_email_verification.otp,
        'token': sign_up_email_verification.token,
        'resend_count': sign_up_email_verification.resend_count,
        'last_resend_at': sign_up_email_verification.last_resend_at.isoformat() if sign_up_email_verification.last_resend_at else None,
        'status': sign_up_email_verification.status.value,
        'created_at': sign_up_email_verification.created_at.isoformat(),
        'modified_at': sign_up_email_verification.modified_at.isoformat(),
    }

def serialize_sign_up_mobile_verification(sign_up_phone_verification: SignUpPhoneVerification) -> dict:
    """Serialize SignUpPhoneVerification object for response."""
    return {
        'id': sign_up_phone_verification.id,
        'phone_number': sign_up_phone_verification.phone_number,
        'is_phone_verified': sign_up_phone_verification.is_phone_verified,
        'otp': sign_up_phone_verification.otp,
        'token': sign_up_phone_verification.token,
        'resend_count': sign_up_phone_verification.resend_count,
        'last_resend_at': sign_up_phone_verification.last_resend_at.isoformat() if sign_up_phone_verification.last_resend_at else None,
        'status': sign_up_phone_verification.status.value,
        'created_at': sign_up_phone_verification.created_at.isoformat(),
        'modified_at': sign_up_phone_verification.modified_at.isoformat(),
    }    
